# -*- coding: utf-8 -*-
'''
Created on 2010-7-16

@author: GL
'''
import urllib
from urllib import addinfourl as rawaddinfourl
class addinfourlstatus(rawaddinfourl):
    def __init__(self, fp, headers, url, status=200, errmsg=None):
        rawaddinfourl.__init__(self, fp, headers, url)
        self.status = status
        self.errmsg = errmsg

urllib.addinfourl = addinfourlstatus

class SimpleURLopener(urllib.FancyURLopener):
    def __init__(self, proxies=None, **x509):
        urllib.FancyURLopener.__init__(self, proxies, **x509)
        self.addheaders = []

    def http_error_default(self, url, fp, errcode, errmsg, headers):
        return addinfourlstatus(fp, headers, url, errcode, errmsg)

    def http_error_302(self, url, fp, errcode, errmsg, headers, data=None):
        #TODO: handle redirect from http to https of same address
        result = self.http_error_default(url, fp, errcode, errmsg, headers)
        return result

    #TODO: handle put delete ...

